﻿using AdventOfCode.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AdventOfCode._2024
{
    public class Day1 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var leftList = this.GetSplitInput().Select(x => int.Parse(x.Split("   ")[0])).OrderBy(x => x).ToArray();
            var rightList = this.GetSplitInput().Select(x => int.Parse(x.Split("   ")[1])).OrderBy(x => x).ToArray();

            var totalDistance = 0;
            for (int i = 0; i < leftList.Length; i++)
            {
                totalDistance += Math.Abs(leftList[i]-rightList[i]);
            }
            Answer = totalDistance;
            return this._response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var leftList = this.GetSplitInput().Select(x => int.Parse(x.Split("   ")[0])).GroupBy(x => x)
                .ToDictionary(group => group.Key, group => group.Count());
            var rightList = this.GetSplitInput().Select(x => int.Parse(x.Split("   ")[1])).GroupBy(x => x)
                .ToDictionary(group => group.Key, group => group.Count());

            var similarityScore = 0;
            foreach (var input in leftList)
            {
                var targetOccurence = 0;
                _ =rightList.TryGetValue(input.Key, out targetOccurence);
                var score = targetOccurence * input.Key; //To generate the similarity score
                similarityScore += score * input.Value; //Score * num of occurence in source lust
            }
            Answer = similarityScore;
            return this._response;
        }
    }
}
